package com.microservices.system.controller;

import com.microservices.common.core.domain.R;
import com.microservices.common.core.web.controller.BaseController;
import com.microservices.common.core.web.domain.AjaxResult;
import com.microservices.common.core.web.page.TableDataInfo;
import com.microservices.common.log.annotation.Log;
import com.microservices.common.log.enums.BusinessType;
import com.microservices.common.security.annotation.InnerAuth;
import com.microservices.common.security.annotation.RequiresPermissions;
import com.microservices.common.security.utils.SecurityUtils;
import com.microservices.system.api.domain.SysNotice;
import com.microservices.system.service.ISysNoticeService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 公告 信息操作处理
 *
 * @author microservices
 */
@RestController
@RequestMapping("/notice")
public class SysNoticeController extends BaseController
{
    @Autowired
    private ISysNoticeService noticeService;

    /**
     * 获取通知公告列表
     */
    @RequiresPermissions("system:notice:list")
    @GetMapping("/list")
    public TableDataInfo list(SysNotice notice)
    {
        startPage();
        List<SysNotice> list = noticeService.selectNoticeList(notice);
        return getDataTable(list);
    }

    /**
     * 根据通知公告编号获取详细信息
     */
    @RequiresPermissions("system:notice:query")
    @GetMapping(value = "/{noticeId}")
    public AjaxResult getInfo(@PathVariable Long noticeId)
    {
        return success(noticeService.selectNoticeById(noticeId));
    }

    /**
     * 根据通知公告编号获取详细信息
     */
    @GetMapping(value = "/innerGetInfo/{noticeId}")
    public R<SysNotice> innerGetInfo(@PathVariable Long noticeId)
    {
        return R.ok(noticeService.selectNoticeById(noticeId));
    }

    /**
     * 新增通知公告
     */
    @RequiresPermissions("system:notice:add")
    @Log(title = "通知公告", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysNotice notice)
    {
        notice.setCreateBy(SecurityUtils.getUsername());
        notice.setUpdateBy(SecurityUtils.getUsername());
        return success(noticeService.insertNotice(notice));
    }

    /**
     * 新增通知公告-内部调用
     */
    @InnerAuth
    @Log(title = "通知公告-内部调用", businessType = BusinessType.INSERT)
    @PostMapping("/innerAdd")
    @ApiOperation(value = "新增通知公告-内部调用", hidden = true)
    public R<Long> innerAdd(@Validated @RequestBody SysNotice notice)
    {
        notice.setCreateBy(SecurityUtils.getUsername());
        notice.setUpdateBy(SecurityUtils.getUsername());
        return R.ok(noticeService.insertNoticeAnReturnId(notice));
    }

    /**
     * 修改通知公告
     */
    @RequiresPermissions("system:notice:edit")
    @Log(title = "通知公告", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysNotice notice)
    {
        notice.setUpdateBy(SecurityUtils.getUsername());
        return toAjax(noticeService.updateNotice(notice));
    }

    /**
     * 修改通知公告-内部调用
     */
    @Log(title = "通知公告-内部调用", businessType = BusinessType.UPDATE)
    @PutMapping("/innerEdit")
    @InnerAuth
    @ApiOperation(value = "修改通知公告-内部调用", hidden = true)
    public R<Integer> innerEdit(@Validated @RequestBody SysNotice notice)
    {
        notice.setUpdateBy(SecurityUtils.getUsername());
        return R.ok(noticeService.updateNotice(notice));
    }

    /**
     * 删除通知公告
     */
    @RequiresPermissions("system:notice:remove")
    @Log(title = "通知公告", businessType = BusinessType.DELETE)
    @DeleteMapping("/{noticeIds}")
    public AjaxResult remove(@PathVariable Long[] noticeIds)
    {
        return toAjax(noticeService.deleteNoticeByIds(noticeIds));
    }

    /**
     * 删除通知公告-内部调用
     */
    @Log(title = "通知公告-内部调用", businessType = BusinessType.UPDATE)
    @DeleteMapping("/innerRemove/{noticeIds}")
    @InnerAuth
    @ApiOperation(value = "删除通知公告-内部调用", hidden = true)
    public R<Integer> innerRemove(@PathVariable Long[] noticeIds)
    {
        return R.ok(noticeService.deleteNoticeByIds(noticeIds));
    }
}
